#!/bin/bash
#
# one possibility:
# put in /etc/rc.d/init.d as runmnd.sh
# ln -s inside rc2.d, rc3,d, rc5.d as filename S98mnd
# e.g.,
#	# ln -s mnd ../rc2.d/S98mnd
#	# ln -s mnd ../rc2.d/S98mnd
#	# ln -s mnd ../rc2.d/S98mnd
# note: DEVICE must match what is in /etc/mnd.conf mn line
#
# syntax: to start, # runmnd.sh start
#	  to stop,  # runmnd.sh stop

# make sure 1st two are correct
MYIP=131.252.222.XX
DEVICE="eth0"
MYROUTER=131.252.222.65
NETMASK=255.255.255.192

case "$1" in
  *)
  start)
	echo -n "Starting mnd services: "
	/sbin/ifconfig $DEVICE $MYIP netmask $NETMASK
	/sbin/route add default gw $MYROUTER
	/usr/sbin/mnd -c /etc/mnd.conf
	;;
  stop)
	echo -n "Shutting down mnd services: "
	kill -HUP `cat /var/run/mipd.pid`
	echo
	;;
  restart|reload)
	$0 stop
	$0 start
	;;
  help)
	echo "Usage: mnd {start|stop|restart|reload}"
	exit 1
esac

exit 0
