#ifndef TUNNEL_H
#define TUNNEL_H
#define IFNAMSIZ 16
#include <asm/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <linux/if_tunnel.h>
#include <linux/netlink.h>

/*
 * mn tunnel list
 */
struct tlist {
	struct in_addr mn;
	char	tunnel[IFNAMSIZ];
	struct  tlist *next;
};

/* establish tunnel type
*/ 
int init_tunnel_param(struct ip_tunnel_parm *tun_param,const char *dev,int ttl,
                                        __u32 remote, __u32 local);
int tunnel_msg(int cmd,void *ifr);
int set_tunnel_up(const char *dev);
int set_tunnel_down(const char *dev);
int check_tunnel(struct ifreq *ifptr,const char *dev);
int add_tunnel( const char *dev,struct in_addr remote, struct in_addr local);
//int del_tunnel(struct tlist **head, struct in_addr dst,const char *dev);
int add_tunnel_ip(int cmd,const char *dev, struct in_addr addr);
//int rt_add(struct in_addr dst,char *dev);
//int rt_del( struct in_addr dst,const  char *dev);
//void ha_route_add_tunnel(struct in_addr mn_addr, struct in_addr coa_addr,
//struct in_addr ha_addr, const char *dev,struct tlist **head);                                
//void ha_route_delete_tunnel(struct tlist **head, struct in_addr dst,const char *dev);

/*tlist prototypes
*/
struct tlist * tlist_search(struct tlist *, struct in_addr,const char *dev );
int tunnel_search(struct tlist *head,const char *dev);
struct tlist * tlist_create(struct tlist **, struct in_addr,const char *dev );
void tlist_delete(struct tlist **, struct in_addr,const char *dev );
void tlist_dump(struct tlist *);


#endif



